%if ! (0%{?fedora} > 12 || 0%{?rhel} > 5)
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

%global year        2011
%global month       09
%global extraver    1
%global pkgname     RDKit_%{year}_%{month}_%{extraver}
%global docdir      %{_docdir}/%{name}-%{version}


%global do_tests 1


Name:           rdkit
Version:        %{year}.%{month}
Release:        2.20111202svn1877%{?dist}
Summary:        A toolkit for cheminformatics and machine learning 
Group:          System Environment/Libraries
License:        BSD
URL:            http://www.rdkit.org/
#Source0:        http://rdkit.googlecode.com/files/%{pkgname}.tgz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# For now, use a snapshot from the "packaging" branch:
# http://rdkit.svn.sourceforge.net/viewvc/rdkit/branches/Packaging_12July2010/
# download it from:
# http://rdkit.svn.sourceforge.net/viewvc/rdkit/branches/Packaging_12July2010/?view=tar
Source0:        rdkit-20111202svn1877.tar.gz
%global pkgname     trunk


BuildRequires:  cmake
BuildRequires:  flex
BuildRequires:  bison
BuildRequires:  python-devel
BuildRequires:  boost-devel >= 1.39
BuildRequires:  postgresql-devel
BuildRequires:  numpy
BuildRequires:  inchi-devel
BuildRequires:  chrpath

Patch1:         rdkit-20111202svn1877-pgsql.patch
Patch2:         rdkit-2011.09-dont_build_static_libs.patch

# we don't want to provide private python extension libs, snippet from:
# http://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering
%{?filter_setup:
%filter_provides_in %{python_sitearch}/.*\.so$ 
%filter_setup
}


%description
A software suite for cheminformatics, computational chemistry, 
and predictive modeling


%package devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       cmake
Requires:       python-devel
Requires:       boost-devel

%description devel
The %{name}-devel package contains libraries, build data, and header
files for developing applications that use %{name}.


%package doc
Summary:        Documentation for %{name}
Group:          Documentation
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}

%description doc
Documentation files for %{name}.


%package extras
Summary:        Data, Contrib and Project files for %{name}
Group:          System Environment/Libraries
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}

%description extras
Data, Contrib and Project files for %{name}.


%package -n python-rdkit
Summary:        Python bindings for RDKit libraries
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       numpy

%description -n python-rdkit
Python bindings for RDKit libraries


%package postgresql
Summary:        RDKit cartridge for PostgreSQL
Group:          Applications/Databases
Requires:       %{name} = %{version}-%{release}
Requires:       postgresql-server

%description postgresql
PostgreSQL module for RDKit, which implements *mol* datatype to 
describe molecules and *fp* datatype for fingerprints, basic comparison
operations, similarity operation (tanimoto, dice) and  index support 
(using GiST indexing framework).

To complete installation of the cartridge in PostgreSQL, please follow
the steps detailed in:

%{docdir}/README


%prep
%setup -q -n %{pkgname}
%patch1 -p1
%patch2 -p1

%build
%{cmake} . \
        -DRDK_INSTALL_INTREE=OFF \
        -DCMAKE_BUILD_TYPE=RelWithDebInfo
make %{?_smp_mflags}

pushd Code/PgSQL/rdkit
export RDBASE=%{_builddir}/%{pkgname}
make STATIC_LINK=0
chrpath -d rdkit.so
popd


%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

pushd Code/PgSQL/rdkit
make install DESTDIR=%{buildroot}
popd

# remove README and license.txt
rm %{buildroot}/%{_datadir}/RDKit/{README,license.txt}


%if %do_tests
%check 
export RDBASE=%{_builddir}/%{pkgname}
export LD_LIBRARY_PATH=$RDBASE/lib
export PYTHONPATH=$RDBASE
make test
%endif


# TO BE REMOVED in F-13 and newer
%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc license.txt ReleaseNotes.txt
%{_libdir}/lib*.so.*

%files devel
%defattr(-,root,root,-)
%{_includedir}/rdkit
%{_libdir}/lib*.so
# FIXME: maybe these should live elsewhere?
%{_libdir}/*.cmake 

%files doc
%defattr(-,root,root,-)
%{_datadir}/RDKit/Docs

%files extras
%defattr(-,root,root,-)
%{_datadir}/RDKit/Projects
%{_datadir}/RDKit/Data
%{_datadir}/RDKit/Contrib

%files -n python-rdkit
%defattr(-,root,root,-)
%{python_sitearch}/rdkit

%files postgresql
%defattr(-,root,root,-)
%doc Code/PgSQL/rdkit/README
%{_libdir}/pgsql/rdkit.so
%{_datadir}/pgsql/extension/rdkit--3.1.sql
%{_datadir}/pgsql/extension/rdkit.control


%changelog
* Mon Dec 05 2011 Gianluca Sforna <giallu@gmail.com> - 2011.09-2
- Package a newer snapshot for postgres 9.1 support
- Remove rpath from postgres cartridge

* Fri Nov 25 2011 Gianluca Sforna <giallu@gmail.com> - 2011.09-1
- New upstream release
- rebase patches
- drop upstreamed patch

* Mon Aug 15 2011 Gianluca Sforna <giallu@gmail.com> - 2011.06-2
- Final release
- add SDMOlsupplier patch, fixes loop on tests

* Wed Jul  6 2011 Gianluca Sforna <giallu@gmail.com> - 2011.06-1
- New upstream (beta) release
- rebase patches

* Mon Jun 13 2011 Gianluca Sforna <giallu@gmail.com> - 2011.03-1
- New upstream release
- drop upstreamed patch

* Wed Apr  6 2011 Gianluca Sforna <giallu@gmail.com> - 2010.12-3
- Add draw_refactoring patch

* Fri Jan 14 2011 Gianluca Sforna <giallu@gmail.com> - 2010.12-2
- New upstream release
- filter auto-provides for python extensions

* Thu Dec 30 2010 Gianluca Sforna <giallu@gmail.com> - 2010.12-1
- New upstream (beta) release
- drop upstream patch
- add patches for rpath, static libs
- Fix spurious executable bits

* Mon Oct  4 2010 Gianluca Sforna <giallu@gmail.com> - 2010.09-1
- New upstream release
- Move build in tree to support tests
- build PostgreSQL cartridge

* Tue Sep  7 2010 Gianluca Sforna <giallu gmail com>
- Split subpackages

* Mon Jul  5 2010 Gianluca Sforna <giallu gmail com> - 2010.Q2-1
- Initial package
